diff -ruN qmail-1.03-orig/Makefile qmail-1.03-ldap-20060201-orig/Makefile
--- qmail-1.03-orig/Makefile	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/Makefile	2006-02-25 11:00:55.000000000 +0100
@@ -1262,18 +1702,26 @@
 
 qmail-newu.o: \
 compile qmail-newu.c stralloc.h gen_alloc.h subfd.h substdio.h \
-getln.h substdio.h cdbmss.h cdbmake.h uint32.h substdio.h exit.h \
-readwrite.h open.h error.h case.h auto_qmail.h
+getln.h substdio.h cdb_make.h uint32.h substdio.h exit.h readwrite.h \
+open.h error.h case.h auto_qmail.h
 	./compile qmail-newu.c
 
+qmail-pbsdbd.run: \
+qmail-pbsdbd.sh conf-qmail
+	cat qmail-pbsdbd.sh \
+	| sed s}%QMAIL%}"`head -1 conf-qmail`"}g \
+	> qmail-pbsdbd.run
+	chmod 755 qmail-pbsdbd.run
+
 qmail-pop3d: \
 load qmail-pop3d.o commands.o case.a timeoutread.o timeoutwrite.o \
-maildir.o prioq.o now.o env.a strerr.a sig.a open.a getln.a \
-stralloc.a alloc.a substdio.a error.a str.a fs.a socket.lib
-	./load qmail-pop3d commands.o case.a timeoutread.o \
+maildir.o prioq.o now.o env.a strerr.a sig.a open.a getln.a str.a \
+stralloc.a alloc.a substdio.a error.a fs.a socket.lib maildir++.o \
+seek.a
+	./load qmail-pop3d commands.o maildir++.o case.a timeoutread.o \
 	timeoutwrite.o maildir.o prioq.o now.o env.a strerr.a sig.a \
 	open.a getln.a stralloc.a alloc.a substdio.a error.a str.a \
-	fs.a  `cat socket.lib`
+	fs.a  seek.a `cat socket.lib`
 
 qmail-pop3d.0: \
 qmail-pop3d.8
@@ -1283,8 +1731,22 @@
 compile qmail-pop3d.c commands.h sig.h getln.h stralloc.h gen_alloc.h \
 substdio.h alloc.h open.h prioq.h datetime.h gen_alloc.h scan.h fmt.h \
 str.h exit.h maildir.h strerr.h readwrite.h timeoutread.h \
-timeoutwrite.h
-	./compile qmail-pop3d.c
+timeoutwrite.h maildir++.h
+	./compile $(LDAPFLAGS) $(MNW) qmail-pop3d.c
+
+qmail-pop3d-ssl.run: \
+qmail-pop3d-ssl.sh conf-qmail
+	cat qmail-pop3d-ssl.sh \
+	| sed s}%QMAIL%}"`head -1 conf-qmail`"}g \
+	> qmail-pop3d-ssl.run
+	chmod 755 qmail-pop3d-ssl.run
+
+qmail-pop3d.run: \
+qmail-pop3d.sh conf-qmail
+	cat qmail-pop3d.sh \
+	| sed s}%QMAIL%}"`head -1 conf-qmail`"}g \
+	> qmail-pop3d.run
+	chmod 755 qmail-pop3d.run
 
 qmail-popup: \
 load qmail-popup.o commands.o timeoutread.o timeoutwrite.o now.o \
@@ -1302,7 +1764,7 @@
 compile qmail-popup.c commands.h fd.h sig.h stralloc.h gen_alloc.h \
 substdio.h alloc.h wait.h str.h byte.h now.h datetime.h fmt.h exit.h \
 readwrite.h timeoutread.h timeoutwrite.h
-	./compile qmail-popup.c
+	./compile $(DEBUG) qmail-popup.c
 
 qmail-pw2u: \
 load qmail-pw2u.o constmap.o control.o open.a getln.a case.a getopt.a \
@@ -1334,11 +1796,13 @@
 qmail-qmqpc: \
 load qmail-qmqpc.o slurpclose.o timeoutread.o timeoutwrite.o \
 timeoutconn.o ip.o control.o auto_qmail.o sig.a ndelay.a open.a \
-getln.a substdio.a stralloc.a alloc.a error.a str.a fs.a socket.lib
+getln.a substdio.a stralloc.a alloc.a error.a str.a fs.a socket.lib \
+dns.lib
 	./load qmail-qmqpc slurpclose.o timeoutread.o \
 	timeoutwrite.o timeoutconn.o ip.o control.o auto_qmail.o \
 	sig.a ndelay.a open.a getln.a substdio.a stralloc.a alloc.a \
-	error.a str.a fs.a  `cat socket.lib`
+	error.a fs.a dns.o str.a ipalloc.o `cat dns.lib` `cat socket.lib` \
+	$(ZLIB)
 
 qmail-qmqpc.0: \
 qmail-qmqpc.8
@@ -1347,15 +1811,15 @@
 qmail-qmqpc.o: \
 compile qmail-qmqpc.c substdio.h getln.h readwrite.h exit.h \
 stralloc.h gen_alloc.h slurpclose.h error.h sig.h ip.h timeoutconn.h \
-timeoutread.h timeoutwrite.h auto_qmail.h control.h fmt.h
-	./compile qmail-qmqpc.c
+timeoutread.h timeoutwrite.h auto_qmail.h control.h fmt.h ipalloc.h
+	./compile $(LDAPFLAGS) $(ZINCLUDES) qmail-qmqpc.c
 
 qmail-qmqpd: \
 load qmail-qmqpd.o received.o now.o date822fmt.o qmail.o auto_qmail.o \
 env.a substdio.a sig.a error.a wait.a fd.a str.a datetime.a fs.a
 	./load qmail-qmqpd received.o now.o date822fmt.o qmail.o \
 	auto_qmail.o env.a substdio.a sig.a error.a wait.a fd.a \
-	str.a datetime.a fs.a 
+	str.a datetime.a fs.a $(ZLIB)
 
 qmail-qmqpd.0: \
 qmail-qmqpd.8
@@ -1364,17 +1828,24 @@
 qmail-qmqpd.o: \
 compile qmail-qmqpd.c auto_qmail.h qmail.h substdio.h received.h \
 sig.h substdio.h readwrite.h exit.h now.h datetime.h fmt.h env.h
-	./compile qmail-qmqpd.c
+	./compile $(LDAPFLAGS) $(ZINCLUDES) qmail-qmqpd.c
+
+qmail-qmqpd.run: \
+qmail-qmqpd.sh conf-qmail
+	cat qmail-qmqpd.sh \
+	| sed s}%QMAIL%}"`head -1 conf-qmail`"}g \
+	> qmail-qmqpd.run
+	chmod 755 qmail-qmqpd.run
 
 qmail-qmtpd: \
 load qmail-qmtpd.o rcpthosts.o control.o constmap.o received.o \
-date822fmt.o now.o qmail.o cdb.a fd.a wait.a datetime.a open.a \
-getln.a sig.a case.a env.a stralloc.a alloc.a substdio.a error.a \
-str.a fs.a auto_qmail.o
+date822fmt.o now.o qmail.o cdb.a fd.a seek.a wait.a datetime.a \
+open.a getln.a sig.a case.a env.a stralloc.a alloc.a substdio.a \
+error.a str.a fs.a auto_qmail.o
 	./load qmail-qmtpd rcpthosts.o control.o constmap.o \
-	received.o date822fmt.o now.o qmail.o cdb.a fd.a wait.a \
-	datetime.a open.a getln.a sig.a case.a env.a stralloc.a \
-	alloc.a substdio.a error.a str.a fs.a auto_qmail.o 
+	received.o date822fmt.o now.o qmail.o cdb.a fd.a seek.a \
+	wait.a datetime.a open.a getln.a sig.a case.a env.a \
+	stralloc.a alloc.a substdio.a error.a str.a fs.a auto_qmail.o 
 
 qmail-qmtpd.0: \
 qmail-qmtpd.8
@@ -1421,11 +1892,12 @@
 qmail-queue: \
 load qmail-queue.o triggerpull.o fmtqfn.o now.o date822fmt.o \
 datetime.a seek.a ndelay.a open.a sig.a alloc.a substdio.a error.a \
-str.a fs.a auto_qmail.o auto_split.o auto_uids.o
-	./load qmail-queue triggerpull.o fmtqfn.o now.o \
-	date822fmt.o datetime.a seek.a ndelay.a open.a sig.a \
-	alloc.a substdio.a error.a str.a fs.a auto_qmail.o \
-	auto_split.o auto_uids.o 
+str.a fs.a auto_qmail.o auto_split.o auto_uids.o control.o constmap.o \
+stralloc.a case.a getln.a
+	./load qmail-queue triggerpull.o fmtqfn.o now.o control.o \
+	constmap.o date822fmt.o datetime.a seek.a ndelay.a open.a sig.a \
+	stralloc.a getln.a case.a alloc.a substdio.a error.a str.a fs.a \
+	auto_qmail.o auto_split.o auto_uids.o 
 
 qmail-queue.0: \
 qmail-queue.8
@@ -1435,18 +1907,37 @@
 compile qmail-queue.c readwrite.h sig.h exit.h open.h seek.h fmt.h \
 alloc.h substdio.h datetime.h now.h datetime.h triggerpull.h extra.h \
 auto_qmail.h auto_uids.h date822fmt.h fmtqfn.h
-	./compile qmail-queue.c
+	./compile $(LDAPFLAGS) qmail-queue.c
+
+qmail-quotawarn: \
+load qmail-quotawarn.o newfield.o now.o date822fmt.o mailmagic.o case.a \
+control.o fd.a wait.a open.a myctime.o case.a getln.a sig.a open.a seek.a \
+lock.a datetime.a env.a stralloc.a alloc.a strerr.a substdio.a error.a str.a \
+fs.a auto_qmail.o
+	./load qmail-quotawarn newfield.o now.o date822fmt.o mailmagic.o \
+	case.a control.o fd.a wait.a open.a myctime.o case.a getln.a sig.a \
+	open.a seek.a lock.a datetime.a env.a stralloc.a alloc.a strerr.a \
+	substdio.a error.a str.a fs.a auto_qmail.o
+
+qmail-quotawarn.o: \
+compile qmail-quotawarn.c auto_qmail.h byte.h case.h control.h date822fmt.h \
+datetime.h env.h error.h exit.h fmt.h getln.h mailmagic.h myctime.h \
+newfield.h now.h open.h qmail-ldap.h seek.h sig.h str.h strerr.h substdio.h \
+wait.h lock.h
+	./compile qmail-quotawarn.c
 
 qmail-remote: \
 load qmail-remote.o control.o constmap.o timeoutread.o timeoutwrite.o \
-timeoutconn.o tcpto.o now.o dns.o ip.o ipalloc.o ipme.o quote.o \
-ndelay.a case.a sig.a open.a lock.a seek.a getln.a stralloc.a alloc.a \
-substdio.a error.a str.a fs.a auto_qmail.o dns.lib socket.lib
+timeoutconn.o tcpto.o now.o dns.o ip.o ipalloc.o ipme.o quote.o xtext.o \
+base64.o ndelay.a case.a sig.a open.a lock.a seek.a getln.a stralloc.a \
+alloc.a strerr.a substdio.a error.a str.a fs.a auto_qmail.o \
+dns.lib socket.lib
 	./load qmail-remote control.o constmap.o timeoutread.o \
 	timeoutwrite.o timeoutconn.o tcpto.o now.o dns.o ip.o \
-	ipalloc.o ipme.o quote.o ndelay.a case.a sig.a open.a \
-	lock.a seek.a getln.a stralloc.a alloc.a substdio.a error.a \
-	str.a fs.a auto_qmail.o  `cat dns.lib` `cat socket.lib`
+	ipalloc.o ipme.o quote.o xtext.o base64.o ndelay.a case.a \
+	sig.a open.a lock.a seek.a getln.a stralloc.a alloc.a \
+	strerr.a substdio.a error.a str.a fs.a auto_qmail.o \
+	`cat dns.lib` `cat socket.lib` $(TLSLIBS) $(ZLIB)
 
 qmail-remote.0: \
 qmail-remote.8
@@ -1458,7 +1949,24 @@
 alloc.h quote.h ip.h ipalloc.h ip.h gen_alloc.h ipme.h ip.h ipalloc.h \
 gen_alloc.h gen_allocdefs.h str.h now.h datetime.h exit.h constmap.h \
 tcpto.h readwrite.h timeoutconn.h timeoutread.h timeoutwrite.h
-	./compile qmail-remote.c
+	./compile $(LDAPFLAGS) $(TLS) $(TLSINCLUDES) $(ZINCLUDES) \
+	qmail-remote.c
+
+qmail-reply: \
+load qmail-reply.o mailmagic.o case.a control.o constmap.o getln.a \
+sig.a newfield.o now.o date822fmt.o datetime.a open.a seek.a env.a \
+qmail.o getopt.a fd.a wait.a digest_md5.o base64.o stralloc.a alloc.a \
+strerr.a substdio.a error.a str.a fs.a auto_qmail.o
+	./load qmail-reply mailmagic.o case.a control.o constmap.o \
+	getln.a sig.a newfield.o now.o date822fmt.o datetime.a open.a \
+	seek.a env.a qmail.o getopt.a fd.a wait.a digest_md5.o base64.o \
+	stralloc.a alloc.a strerr.a substdio.a error.a str.a fs.a auto_qmail.o
+
+qmail-reply.o: \
+compile qmail-reply.c byte.h case.h control.h constmap.h direntry.h env.h \
+error.h exit.h getln.h newfield.h now.h open.h qmail.h qmail-ldap.h \
+readwrite.h seek.h sgetopt.h strerr.h stralloc.h substdio.h uint32.h
+	./compile $(LDAPFLAGS) qmail-reply.c
 
 qmail-rspawn: \
 load qmail-rspawn.o spawn.o tcpto_clean.o now.o coe.o sig.a open.a \
@@ -1478,17 +1986,34 @@
 tcpto.h
 	./compile qmail-rspawn.c
 
+qmail-secretary: \
+load qmail-secretary.o base64.o digest_sha1.o control.o newfield.o now.o \
+date822fmt.o datetime.a mailmaker.o mailmagic.o case.a getln.a qmail.o \
+quote.o getopt.a seek.a fd.a wait.a sig.a open.a stralloc.a env.a alloc.a \
+strerr.a substdio.a error.a str.a fs.a auto_qmail.o
+	./load qmail-secretary base64.o digest_sha1.o control.o newfield.o \
+	now.o date822fmt.o datetime.a mailmaker.o mailmagic.o case.a getln.a \
+	qmail.o quote.o getopt.a seek.a fd.a wait.a sig.a open.a stralloc.a \
+	env.a alloc.a strerr.a substdio.a error.a str.a fs.a auto_qmail.o
+	
+qmail-secretary.o: \
+compile qmail-secretary.c uint32.h base64.h byte.h case.h digest_sha1.h \
+direntry.h env.h error.h fd.h fmt.h getln.h mailmagic.h newfield.h now.h \
+open.h qmail.h quote.h readwrite.h seek.h sgetopt.h sig.h str.h stralloc.h \
+strerr.h substdio.h wait.h qldap-errno.h mailmaker.h
+	./compile $(LDAPFLAGS) $(MDIRMAKE) qmail-secretary.c
+
 qmail-send: \
 load qmail-send.o qsutil.o control.o constmap.o newfield.o prioq.o \
 trigger.o fmtqfn.o quote.o now.o readsubdir.o qmail.o date822fmt.o \
-datetime.a case.a ndelay.a getln.a wait.a seek.a fd.a sig.a open.a \
-lock.a stralloc.a alloc.a substdio.a error.a str.a fs.a auto_qmail.o \
-auto_split.o
+datetime.a case.a ndelay.a getln.a wait.a cdb.a seek.a fd.a sig.a \
+open.a lock.a stralloc.a env.a alloc.a substdio.a error.a str.a fs.a \
+auto_qmail.o auto_split.o
 	./load qmail-send qsutil.o control.o constmap.o newfield.o \
 	prioq.o trigger.o fmtqfn.o quote.o now.o readsubdir.o \
 	qmail.o date822fmt.o datetime.a case.a ndelay.a getln.a \
-	wait.a seek.a fd.a sig.a open.a lock.a stralloc.a alloc.a \
-	substdio.a error.a str.a fs.a auto_qmail.o auto_split.o 
+	wait.a cdb.a seek.a fd.a sig.a open.a lock.a stralloc.a env.a \
+	alloc.a substdio.a error.a str.a fs.a auto_qmail.o auto_split.o 
 
 qmail-send.0: \
 qmail-send.8
@@ -1508,8 +2033,8 @@
 substdio.h alloc.h error.h stralloc.h gen_alloc.h str.h byte.h fmt.h \
 scan.h case.h auto_qmail.h trigger.h newfield.h stralloc.h quote.h \
 qmail.h substdio.h qsutil.h prioq.h datetime.h gen_alloc.h constmap.h \
-fmtqfn.h readsubdir.h direntry.h
-	./compile qmail-send.c
+fmtqfn.h readsubdir.h direntry.h cdb.h uint32.h
+	./compile $(LDAPFLAGS) qmail-send.c
 
 qmail-showctl: \
 load qmail-showctl.o auto_uids.o control.o open.a getln.a stralloc.a \
@@ -1532,17 +2057,19 @@
 	./compile qmail-showctl.c
 
 qmail-smtpd: \
-load qmail-smtpd.o rcpthosts.o commands.o timeoutread.o \
+load qmail-smtpd.o rcpthosts.o commands.o timeoutread.o rbl.o \
 timeoutwrite.o ip.o ipme.o ipalloc.o control.o constmap.o received.o \
-date822fmt.o now.o qmail.o cdb.a fd.a wait.a datetime.a getln.a \
-open.a sig.a case.a env.a stralloc.a alloc.a substdio.a error.a str.a \
-fs.a auto_qmail.o socket.lib
-	./load qmail-smtpd rcpthosts.o commands.o timeoutread.o \
+date822fmt.o now.o qmail.o execcheck.o cdb.a smtpcall.o coe.o fd.a \
+seek.a wait.a datetime.a getln.a open.a sig.a case.a env.a stralloc.a \
+alloc.a substdio.a error.a str.a fs.a auto_qmail.o auto_break.o \
+dns.lib socket.lib
+	./load qmail-smtpd rcpthosts.o commands.o timeoutread.o rbl.o \
 	timeoutwrite.o ip.o ipme.o ipalloc.o control.o constmap.o \
-	received.o date822fmt.o now.o qmail.o cdb.a fd.a wait.a \
-	datetime.a getln.a open.a sig.a case.a env.a stralloc.a \
-	alloc.a substdio.a error.a str.a fs.a auto_qmail.o  `cat \
-	socket.lib`
+	received.o date822fmt.o now.o qmail.o execcheck.o cdb.a \
+	smtpcall.o coe.o fd.a seek.a wait.a datetime.a getln.a \
+	open.a sig.a case.a env.a stralloc.a alloc.a substdio.a \
+	error.a fs.a auto_qmail.o dns.o str.a auto_break.o \
+	`cat dns.lib` `cat socket.lib` $(TLSLIBS) $(ZLIB)
 
 qmail-smtpd.0: \
 qmail-smtpd.8
@@ -1553,8 +2080,17 @@
 substdio.h alloc.h auto_qmail.h control.h received.h constmap.h \
 error.h ipme.h ip.h ipalloc.h ip.h gen_alloc.h ip.h qmail.h \
 substdio.h str.h fmt.h scan.h byte.h case.h env.h now.h datetime.h \
-exit.h rcpthosts.h timeoutread.h timeoutwrite.h commands.h
-	./compile qmail-smtpd.c
+exit.h rcpthosts.h timeoutread.h timeoutwrite.h commands.h rbl.h \
+qmail-ldap.h auto_break.h
+	./compile $(LDAPFLAGS) $(TLS) $(TLSINCLUDES) $(ZINCLUDES) \
+	qmail-smtpd.c
+
+qmail-smtpd.run: \
+qmail-smtpd.sh conf-qmail
+	cat qmail-smtpd.sh \
+	| sed s}%QMAIL%}"`head -1 conf-qmail`"}g \
+	> qmail-smtpd.run
+	chmod 755 qmail-smtpd.run
 
 qmail-start: \
 load qmail-start.o prot.o fd.a auto_uids.o
@@ -1574,7 +2110,7 @@
 
 qmail-start.o: \
 compile qmail-start.c fd.h prot.h exit.h fork.h auto_uids.h
-	./compile qmail-start.c
+	./compile $(LDAPFLAGS) qmail-start.c
 
 qmail-tcpok: \
 load qmail-tcpok.o open.a lock.a strerr.a substdio.a error.a str.a \
@@ -1606,6 +2142,20 @@
 fmt.h ip.h lock.h error.h exit.h datetime.h now.h datetime.h
 	./compile qmail-tcpto.c
 
+qmail-todo: \
+load qmail-todo.o control.o constmap.o trigger.o fmtqfn.o now.o \
+readsubdir.o case.a ndelay.a getln.a sig.a cdb.a open.a stralloc.a \
+alloc.a substdio.a error.a str.a seek.a fs.a auto_qmail.o auto_split.o
+	./load qmail-todo control.o constmap.o trigger.o fmtqfn.o now.o \
+	readsubdir.o case.a ndelay.a getln.a sig.a cdb.a open.a stralloc.a \
+	alloc.a substdio.a error.a str.a seek.a fs.a auto_qmail.o auto_split.o
+
+qmail-todo.o: \
+compile qmail-todo.c alloc.h auto_qmail.h byte.h cdb.h constmap.h control.h \
+direntry.h error.h exit.h fmt.h fmtqfn.h getln.h open.h ndelay.h now.h \
+readsubdir.h scan.h select.h sig.h str.h stralloc.h substdio.h trigger.h
+	./compile $(LDAPFLAGS) qmail-todo.c
+
 qmail-upq: \
 warn-auto.sh qmail-upq.sh conf-qmail conf-break conf-split
 	cat warn-auto.sh qmail-upq.sh \
@@ -1627,6 +2177,22 @@
 	| sed s}SPAWN}"`head -1 conf-spawn`"}g \
 	> qmail-users.5
 
+qmail-verify: \
+load qmail-verify.o qldap.a read-ctrl.o control.o getln.a substdio.a \
+stralloc.a env.a alloc.a error.a open.a fs.a case.a cdb.a str.a timeoutread.o \
+localdelivery.o auto_qmail.o
+	./load qmail-verify qldap.a read-ctrl.o control.o getln.a \
+	substdio.a stralloc.a env.a alloc.a error.a open.a fs.a case.a \
+	cdb.a str.a seek.a timeoutread.o localdelivery.o auto_qmail.o \
+	$(LDAPLIBS)
+
+qmail-verify.o: \
+compile qmail-verify.c auto_break.h byte.h case.h cdb.h error.h getln.h \
+localdelivery.h open.h output.h qldap.h qldap-debug.h qldap-errno.h \
+qmail-ldap.h read-ctrl.h str.h stralloc.h subfd.h substdio.h \
+timeoutread.h
+	./compile $(LDAPFLAGS) $(DEBUG) qmail-verify.c
+
 qmail.0: \
 qmail.7
 	nroff -man qmail.7 > qmail.0
@@ -1634,7 +2200,14 @@
 qmail.o: \
 compile qmail.c substdio.h readwrite.h wait.h exit.h fork.h fd.h \
 qmail.h substdio.h auto_qmail.h
-	./compile qmail.c
+	./compile $(LDAPFLAGS) qmail.c
+
+qmail.run: \
+qmail.sh conf-qmail
+	cat qmail.sh \
+	| sed s}%QMAIL%}"`head -1 conf-qmail`"}g \
+	> qmail.run
+	chmod 755 qmail.run
 
 qreceipt: \
 load qreceipt.o headerbody.o hfield.o quote.o token822.o qmail.o \
@@ -1676,6 +2249,10 @@
 compile quote.c stralloc.h gen_alloc.h str.h quote.h
 	./compile quote.c
 
+rbl.o: \
+compile rbl.c dns.h env.h ipalloc.h qmail.h rbl.h stralloc.h
+	./compile rbl.c
+
 rcpthosts.o: \
 compile rcpthosts.c cdb.h uint32.h byte.h open.h error.h control.h \
 constmap.h stralloc.h gen_alloc.h rcpthosts.h
@@ -1686,6 +2263,14 @@
 auto_split.h
 	./compile readsubdir.c
 
+readwrite.o: \
+compile readwrite.c readwrite.h
+	./compile readwrite.c
+
+read-ctrl.o: \
+compile read-ctrl.c auto_qmail.h error.h open.h read-ctrl.h
+	./compile read-ctrl.c
+
 received.o: \
 compile received.c fmt.h qmail.h substdio.h now.h datetime.h \
 datetime.h date822fmt.h received.h
@@ -1743,7 +2328,7 @@
 	./compile sendmail.c
 
 setup: \
-it man
+it man ldap
 	./install
 
 sgetopt.o: \
@@ -1795,9 +2380,8 @@
 auto-int8.c auto-gid.c auto-uid.c hier.c install.c instcheck.c \
 install-big.c alloc.3 alloc.h alloc.c alloc_re.c case.3 case.h \
 case_diffb.c case_diffs.c case_lowerb.c case_lowers.c case_starts.c \
-cdb.3 cdb.h cdb_hash.c cdb_seek.c cdb_unpack.c cdbmake.h \
-cdbmake_add.c cdbmake_hash.c cdbmake_pack.c cdbmss.h cdbmss.c coe.3 \
-coe.h coe.c fd.h fd_copy.3 fd_copy.c fd_move.3 fd_move.c fifo_make.3 \
+cdb.3 cdb.c cdb.h cdb_hash.c cdb_make.c cdb_make.h coe.3 coe.h \
+coe.c fd.h fd_copy.3 fd_copy.c fd_move.3 fd_move.c fifo_make.3 \
 fifo.h fifo.c trymkffo.c fork.h1 fork.h2 tryvfork.c now.3 now.h now.c \
 open.h open_append.c open_excl.c open_read.c open_trunc.c \
 open_write.c seek.h seek_cur.c seek_end.c seek_set.c seek_trunc.c \
@@ -1883,6 +2467,11 @@
 error.h
 	./compile slurpclose.c
 
+smtpcall.o: \
+compile smtpcall.c auto_qmail.h coe.h fd.h substdio.h str.h stralloc.h \
+timeoutread.h timeoutwrite.h wait.h smtpcall.h
+	./compile smtpcall.c
+
 socket.lib: \
 trylsock.c compile load
 	( ( ./compile trylsock.c && \
@@ -1895,7 +2484,7 @@
 stralloc.h gen_alloc.h select.h exit.h coe.h open.h error.h \
 auto_qmail.h auto_uids.h auto_spawn.h
 	./chkspawn
-	./compile spawn.c
+	./compile $(DEBUG) spawn.c
 
 splogger: \
 load splogger.o substdio.a error.a str.a fs.a syslog.lib socket.lib
@@ -1914,10 +2503,10 @@
 str.a: \
 makelib str_len.o str_diff.o str_diffn.o str_cpy.o str_chr.o \
 str_rchr.o str_start.o byte_chr.o byte_rchr.o byte_diff.o byte_copy.o \
-byte_cr.o byte_zero.o
+byte_cr.o byte_zero.o byte_repl.o
 	./makelib str.a str_len.o str_diff.o str_diffn.o str_cpy.o \
 	str_chr.o str_rchr.o str_start.o byte_chr.o byte_rchr.o \
-	byte_diff.o byte_copy.o byte_cr.o byte_zero.o
+	byte_diff.o byte_copy.o byte_cr.o byte_zero.o byte_repl.o
 
 str_chr.o: \
 compile str_chr.c str.h
@@ -2036,10 +2625,10 @@
 
 substdio.a: \
 makelib substdio.o substdi.o substdo.o subfderr.o subfdout.o \
-subfdouts.o subfdin.o subfdins.o substdio_copy.o
+subfdouts.o subfdin.o subfdins.o substdio_copy.o readwrite.o
 	./makelib substdio.a substdio.o substdi.o substdo.o \
 	subfderr.o subfdout.o subfdouts.o subfdin.o subfdins.o \
-	substdio_copy.o
+	substdio_copy.o readwrite.o
 
 substdio.o: \
 compile substdio.c substdio.h
@@ -2139,3 +2728,28 @@
 wait_pid.o: \
 compile wait_pid.c error.h haswaitp.h
 	./compile wait_pid.c
+
+xtext.o: \
+compile xtext.c xtext.h stralloc.h
+	./compile xtext.c
+
+cert:
+	$(OPENSSLBIN) req -new -x509 -nodes \
+	-out `head -1 conf-qmail`/control/cert.pem -days 366 \
+	-keyout `head -1 conf-qmail`/control/cert.pem
+	chmod 640 `head -1 conf-qmail`/control/cert.pem
+	chown qmaild:qmail `head -1 conf-qmail`/control/cert.pem
+
+cert-req:
+	$(OPENSSLBIN) req -new -nodes \
+	-out req.pem \
+	-keyout `head -1 conf-qmail`/control/cert.pem
+	chmod 640 `head -1 conf-qmail`/control/cert.pem
+	chown qmaild:qmail `head -1 conf-qmail`/control/cert.pem
+	@echo
+	@echo "Send req.pem to your CA to obtain signed_req.pem, and do:"
+	@echo "cat signed_req.pem >> `head -1 conf-qmail`/control/cert.pem"
+
+backup: \
+clean
+	tar cf $(BACKUPPATH) .
diff -ruN qmail-1.03-orig/Makefile.cdb qmail-1.03-ldap-20060201-orig/Makefile.cdb
--- qmail-1.03-orig/Makefile.cdb	1970-01-01 01:00:00.000000000 +0100
+++ qmail-1.03-ldap-20060201-orig/Makefile.cdb	2006-02-25 11:00:55.000000000 +0100
@@ -0,0 +1,60 @@
+#
+# Copyright (c) 2003-2004 Andre Oppermann, Claudio Jeker,
+#      Internet Business Solutions AG, CH-8005 Zürich, Switzerland
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+# 3. All advertising materials mentioning features or use of this software
+#    must display the following acknowledgement:
+#      This product includes software developed by Internet Business
+#      Solutions AG and its contributors.
+# 4. Neither the name of the author nor the names of its contributors
+#    may be used to endorse or promote products derived from this software
+#    without specific prior written permission.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHORS AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+
+
+# Simple Makefile to keep cdb databases up to date
+# This Makefile assumes that tcprules and qmail-cdb are in your $PATH
+# if not edit the next two lines.
+TCPRULES=tcprules
+QMAILRULES="%QMAIL%/bin/qmail-cdb"
+
+FILES=	locals.cdb rcpthosts.cdb qmail-smtpd.cdb qmail-qmqpd.cdb \
+	qmail-pop3d.cdb qmail-imapd.cdb
+
+TMPFILE=rules.tmp
+
+.SUFFIXES: .cdb .rules
+
+all: $(FILES)
+	@rm -f $(TMPFILE)
+
+# locals and rcpthosts are special cases...
+locals.cdb: locals
+	$(QMAILRULES) locals.cdb $(TMPFILE) < locals
+
+rcpthosts.cdb: rcpthosts
+	$(QMAILRULES) rcpthosts.cdb $(TMPFILE) < rcpthosts
+
+.rules.cdb:
+	$(TCPRULES) $@ $(TMPFILE) < $<
+
diff -ruN qmail-1.03-orig/myctime.c qmail-1.03-ldap-20060201-orig/myctime.c
--- qmail-1.03-orig/myctime.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/myctime.c	2006-02-25 11:00:55.000000000 +0100
@@ -2,10 +2,10 @@
 #include "fmt.h"
 #include "myctime.h"
 
-static char *daytab[7] = {
+static const char *daytab[7] = {
 "Sun","Mon","Tue","Wed","Thu","Fri","Sat"
 };
-static char *montab[12] = {
+static const char *montab[12] = {
 "Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"
 };
 
diff -ruN qmail-1.03-orig/myctime.h qmail-1.03-ldap-20060201-orig/myctime.h
--- qmail-1.03-orig/myctime.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/myctime.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,6 +1,8 @@
 #ifndef MYCTIME_H
 #define MYCTIME_H
 
-extern char *myctime();
+#include "datetime.h"
+
+extern char *myctime(datetime_sec);
 
 #endif
diff -ruN qmail-1.03-orig/ndelay.h qmail-1.03-ldap-20060201-orig/ndelay.h
--- qmail-1.03-orig/ndelay.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/ndelay.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,7 +1,7 @@
 #ifndef NDELAY_H
 #define NDELAY_H
 
-extern int ndelay_on();
-extern int ndelay_off();
+extern int ndelay_on(int fd);
+extern int ndelay_off(int fd);
 
 #endif
diff -ruN qmail-1.03-orig/newfield.c qmail-1.03-ldap-20060201-orig/newfield.c
--- qmail-1.03-orig/newfield.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/newfield.c	2006-02-25 11:00:55.000000000 +0100
@@ -1,3 +1,5 @@
+#include <sys/types.h>
+#include <unistd.h>
 #include "fmt.h"
 #include "datetime.h"
 #include "stralloc.h"
@@ -25,7 +27,7 @@
 
 static unsigned int msgidfmt(s,idhost,idhostlen,when)
 char *s;
-char *idhost;
+const char *idhost;
 int idhostlen;
 datetime_sec when;
 {
@@ -58,7 +60,7 @@
 }
 
 int newfield_msgidmake(idhost,idhostlen,when)
-char *idhost;
+const char *idhost;
 int idhostlen;
 datetime_sec when;
 {
diff -ruN qmail-1.03-orig/newfield.h qmail-1.03-ldap-20060201-orig/newfield.h
--- qmail-1.03-orig/newfield.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/newfield.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,12 +1,13 @@
 #ifndef NEWFIELD_H
 #define NEWFIELD_H
 
+#include "datetime.h"
 #include "stralloc.h"
 
 extern stralloc newfield_date;
-extern int newfield_datemake();
+extern int newfield_datemake(datetime_sec);
 
 extern stralloc newfield_msgid;
-extern int newfield_msgidmake();
+extern int newfield_msgidmake(const char *, int, datetime_sec);
 
 #endif
diff -ruN qmail-1.03-orig/now.c qmail-1.03-ldap-20060201-orig/now.c
--- qmail-1.03-orig/now.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/now.c	2006-02-25 11:00:55.000000000 +0100
@@ -2,7 +2,7 @@
 #include "datetime.h"
 #include "now.h"
 
-datetime_sec now()
+datetime_sec now(void)
 {
-  return time((long *) 0);
+  return time((void *)0);
 }
diff -ruN qmail-1.03-orig/now.h qmail-1.03-ldap-20060201-orig/now.h
--- qmail-1.03-orig/now.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/now.h	2006-02-25 11:00:55.000000000 +0100
@@ -3,6 +3,6 @@
 
 #include "datetime.h"
 
-extern datetime_sec now();
+extern datetime_sec now(void);
 
 #endif
diff -ruN qmail-1.03-orig/open_append.c qmail-1.03-ldap-20060201-orig/open_append.c
--- qmail-1.03-orig/open_append.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/open_append.c	2006-02-25 11:00:55.000000000 +0100
@@ -2,5 +2,5 @@
 #include <fcntl.h>
 #include "open.h"
 
-int open_append(fn) char *fn;
+int open_append(fn) const char *fn;
 { return open(fn,O_WRONLY | O_NDELAY | O_APPEND | O_CREAT,0600); }
diff -ruN qmail-1.03-orig/open_excl.c qmail-1.03-ldap-20060201-orig/open_excl.c
--- qmail-1.03-orig/open_excl.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/open_excl.c	2006-02-25 11:00:55.000000000 +0100
@@ -2,5 +2,5 @@
 #include <fcntl.h>
 #include "open.h"
 
-int open_excl(fn) char *fn;
+int open_excl(fn) const char *fn;
 { return open(fn,O_WRONLY | O_EXCL | O_CREAT,0644); }
diff -ruN qmail-1.03-orig/open.h qmail-1.03-ldap-20060201-orig/open.h
--- qmail-1.03-orig/open.h	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/open.h	2006-02-25 11:00:55.000000000 +0100
@@ -1,10 +1,10 @@
 #ifndef OPEN_H
 #define OPEN_H
 
-extern int open_read();
-extern int open_excl();
-extern int open_append();
-extern int open_trunc();
-extern int open_write();
+extern int open_read(const char *);
+extern int open_excl(const char *);
+extern int open_append(const char *);
+extern int open_trunc(const char *);
+extern int open_write(const char *);
 
 #endif
diff -ruN qmail-1.03-orig/open_read.c qmail-1.03-ldap-20060201-orig/open_read.c
--- qmail-1.03-orig/open_read.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/open_read.c	2006-02-25 11:00:55.000000000 +0100
@@ -2,5 +2,5 @@
 #include <fcntl.h>
 #include "open.h"
 
-int open_read(fn) char *fn;
+int open_read(fn) const char *fn;
 { return open(fn,O_RDONLY | O_NDELAY); }
diff -ruN qmail-1.03-orig/open_trunc.c qmail-1.03-ldap-20060201-orig/open_trunc.c
--- qmail-1.03-orig/open_trunc.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/open_trunc.c	2006-02-25 11:00:55.000000000 +0100
@@ -2,5 +2,5 @@
 #include <fcntl.h>
 #include "open.h"
 
-int open_trunc(fn) char *fn;
+int open_trunc(fn) const char *fn;
 { return open(fn,O_WRONLY | O_NDELAY | O_TRUNC | O_CREAT,0644); }
diff -ruN qmail-1.03-orig/open_write.c qmail-1.03-ldap-20060201-orig/open_write.c
--- qmail-1.03-orig/open_write.c	1998-06-15 12:53:16.000000000 +0200
+++ qmail-1.03-ldap-20060201-orig/open_write.c	2006-02-25 11:00:55.000000000 +0100
@@ -2,5 +2,5 @@
 #include <fcntl.h>
 #include "open.h"
 
-int open_write(fn) char *fn;
+int open_write(fn) const char *fn;
 { return open(fn,O_WRONLY | O_NDELAY); }
